package com.jiuqi.grid;

import com.jiuqi.util.JqLib;
import java.io.Serializable;

public class CellPostion implements Serializable, Cloneable {

   private static final long serialVersionUID = 1500L;
   private int col = -1;
   private int row = -1;


   public CellPostion(int aCol, int aRow) {
      this.col = aCol;
      this.row = aRow;
   }

   public CellPostion(String posStr) {
      int[] posVal = JqLib.stringToColRow(posStr);
      this.col = posVal[0];
      this.row = posVal[1];
   }

   public CellPostion(CellPostion pos) {
      this.col = pos.col;
      this.row = pos.row;
   }

   public int getCol() {
      return this.col;
   }

   public int getRow() {
      return this.row;
   }

   public int hashCode() {
      return this.col << 8 + this.row;
   }

   public String toString() {
      return JqLib.colRowToString(this.col, this.row);
   }

   public boolean equals(Object obj) {
      return this == obj?true:(obj != null && this != null?(!(obj instanceof CellPostion)?false:this.col == ((CellPostion)obj).col && this.row == ((CellPostion)obj).row):false);
   }

   public Object clone() {
      return new CellPostion(this.col, this.row);
   }

   public static void main(String[] args) {
      CellPostion c1 = new CellPostion("A2");
      System.out.println(c1.getCol() + "," + c1.getRow() + ":" + c1);
      System.out.println("hashcode: " + c1.hashCode());
      CellPostion c2 = new CellPostion(1, 2);
      System.out.println(c2.getCol() + "," + c2.getRow() + ":" + c2);
      System.out.println("hashcode: " + c2.hashCode());
      if(c1.equals(c2)) {
         System.out.println("c1=c2");
      }

   }
}
